#include "DirectXParticlePlanarObject.h"

#include "Texture.h"
#include "Graph3D.h"

#include <BaseApp.h>

#include <Renderer.h>

#include <d3d9types.h>
#include <d3d9.h>
#include <stdio.h>


CGDirectXParticlePlanarObject::CGDirectXParticlePlanarObject()
{
	m_pParticlePlanar = new DIRECT3DPARTICLEVERTEX[4];
}

CGDirectXParticlePlanarObject::~CGDirectXParticlePlanarObject()
{
}

// metoda ma wczytywac teksture z pliku i zwrocona ma byc w postaci zrzutowanej na void
void* CGDirectXParticlePlanarObject::LoadTexture(const char* szFileName)
{
	int nL = strlen(szFileName);
	int i = 0;
	for(i=nL-1; i>=0; i--)
	{
		if(szFileName[i]=='/' || szFileName[i]=='\\')
			break;
	}

	char szShortName[1024];
	//sprintf(szShortName, "%s/Textures/Particles/%s", CGBaseApp::GetCurrentDirectory(),szFileName+i+1);
	sprintf(szShortName, "Particles/%s", szFileName+i+1);

	CGTexture* pTexture = CreateTexture_Global(szShortName);
	return (void*)pTexture;
}

// tu trzeba przejsc z void* na klase tekstury i zrobic ja aktywna dla renderingu
// ustawic blending, wylaczyc zapisywanie do z-bufora
void CGDirectXParticlePlanarObject::PrepareToDisplay(void* pTexture, int nAdditive)
{
	CGTexture* pT = (CGTexture*)pTexture;

	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, TRUE);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);	

	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_LIGHTING,FALSE);

	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );
	//Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );
	
	//Graph3D::m_pd3dDevice->SetRenderState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);

	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, TRUE );	

	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, TRUE );
	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHAREF, (DWORD)1 );
	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHAFUNC, D3DCMP_GREATEREQUAL);
	
	if(nAdditive)
	{
		//Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );
		//Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, FALSE );

		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_TEXTURE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_DIFFUSE);

		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_SELECTARG1);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_TEXTURE);

		Graph3D::m_pd3dDevice->SetRenderState( D3DRS_SRCBLEND, D3DBLEND_ONE);
		Graph3D::m_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_ONE);
	}
	else
	{
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLOROP,   D3DTOP_MODULATE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG2, D3DTA_TEXTURE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_COLORARG1, D3DTA_DIFFUSE);

		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAOP,   D3DTOP_MODULATE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG1, D3DTA_DIFFUSE);
		Graph3D::m_pd3dDevice->SetTextureStageState( 0, D3DTSS_ALPHAARG2, D3DTA_TEXTURE);

		Graph3D::m_pd3dDevice->SetRenderState( D3DRS_SRCBLEND,  D3DBLEND_SRCALPHA);
		Graph3D::m_pd3dDevice->SetRenderState( D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA);
	}

	if(pT)
	{
		Graph3D::m_pd3dDevice->SetTexture(0, pT->Get());
	}
	else
	{
		Graph3D::m_pd3dDevice->SetTexture(0, NULL);
	}
	m_nAdditive = nAdditive;
	
	Graph3D::m_pd3dDevice->SetVertexShader(D3DFVF_DIRECT3DPARTICLEVERTEX);
	//Graph3D::m_pd3dDevice->SetFVF(D3DFVF_DIRECT3DPARTICLEVERTEX);
}

// wyswietlenie pojedynczego planara
void CGDirectXParticlePlanarObject::Display()
{
	float fR = (float)m_RGBAColor[0] / 255.0f;
	float fG = (float)m_RGBAColor[1] / 255.0f;
	float fB = (float)m_RGBAColor[2] / 255.0f;
	float fA = (float)m_RGBAColor[3] / 255.0f;

	D3DCOLOR col = D3DCOLOR_RGBA(m_RGBAColor[0], m_RGBAColor[1], m_RGBAColor[2], m_RGBAColor[3]);
	if(m_nAdditive)
	{
		col = D3DCOLOR_RGBA((unsigned char)(((int)m_RGBAColor[0]*(int)m_RGBAColor[3])/255), (unsigned char)(((int)m_RGBAColor[1]*(int)m_RGBAColor[3])/255), (unsigned char)(((int)m_RGBAColor[2]*(int)m_RGBAColor[3])/255), 255);
		fR *= fA;
		fG *= fA;
		fB *= fA;
		fA = 1.0f;
	}

	if(m_nBillboard)
	{
		float fXX = 0.5f * (m_arrX[0]+m_arrX[3]);
		float fYY = 0.5f * (m_arrY[0]+m_arrY[3]);
		float fZZ = 0.5f * (m_arrZ[0]+m_arrZ[3]);

		D3DXVECTOR4 vOut;
		for(int i=0; i<4; i++)
		{
			D3DXVECTOR3 vIn(m_arrX[i]-fXX, m_arrY[i]-fYY, m_arrZ[i]-fZZ);
			D3DXVec3Transform(&vOut, &vIn, &Graph3D::m_matBillboard);

			m_pParticlePlanar[i].position.x = vOut.x+fXX;
			m_pParticlePlanar[i].position.y = vOut.y+fYY;

			m_pParticlePlanar[i].position.x = CGRenderer::X(m_pParticlePlanar[i].position.x)*CGRenderer::m_fScale;
			m_pParticlePlanar[i].position.y = CGRenderer::X(m_pParticlePlanar[i].position.y)*CGRenderer::m_fScale;
			m_pParticlePlanar[i].rhw = 1.0f;
			/*
			if(Graph3D::m_bCamera2D)
			{
				m_pParticlePlanar[i].position.z = 0.0f;
			}
			else
			{
				m_pParticlePlanar[i].position.z = vOut.z+fZZ;
			}
			*/
			m_pParticlePlanar[i].position.z = 0.0f;

			m_pParticlePlanar[i].color = col;
			m_pParticlePlanar[i].tu = m_arrU[i];
			m_pParticlePlanar[i].tv = m_arrV[i];
		}
	}
	else
	{
		for(int i=0; i<4; i++)
		{
			m_pParticlePlanar[i].position.x = m_arrX[i];
			m_pParticlePlanar[i].position.y = m_arrY[i];
			m_pParticlePlanar[i].position.z = m_arrZ[i];
			m_pParticlePlanar[i].color = col;
			m_pParticlePlanar[i].tu = m_arrU[i];
			m_pParticlePlanar[i].tv = m_arrV[i];
		}
	}

	m_ParticleMaterial.Diffuse.r = fR; 
	m_ParticleMaterial.Diffuse.g = fG; 
	m_ParticleMaterial.Diffuse.b = fB; 
	m_ParticleMaterial.Diffuse.a = fA; 

	m_ParticleMaterial.Ambient.r = fR; 
	m_ParticleMaterial.Ambient.g = fG; 
	m_ParticleMaterial.Ambient.b = fB;
	m_ParticleMaterial.Ambient.a = fA;

	m_ParticleMaterial.Emissive.r = fR; 
	m_ParticleMaterial.Emissive.g = fG; 
	m_ParticleMaterial.Emissive.b = fB;
	m_ParticleMaterial.Emissive.a = fA;
	Graph3D::m_pd3dDevice->SetMaterial(&m_ParticleMaterial);

	D3DXMATRIX mat;
	D3DXMatrixIdentity(&mat);
	Graph3D::SetupWorld(mat);
	Graph3D::m_pd3dDevice->DrawPrimitiveUP(D3DPT_TRIANGLESTRIP, 2, (void*)m_pParticlePlanar, sizeof(DIRECT3DPARTICLEVERTEX));
}

// przywrocenie domyslnych ustawien p0o narysowaniu wszytskich planarow
void CGDirectXParticlePlanarObject::RestoreAfterDisplay()
{
	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ZWRITEENABLE, TRUE );
	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_CULLMODE, D3DCULL_CCW);

    Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHABLENDENABLE, FALSE );
	Graph3D::m_pd3dDevice->SetRenderState( D3DRS_ALPHATESTENABLE, FALSE );

	Graph3D::m_pd3dDevice->SetRenderState(D3DRS_MULTISAMPLEANTIALIAS, TRUE);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MAGFILTER, D3DTEXF_LINEAR);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MINFILTER, D3DTEXF_LINEAR);
	Graph3D::m_pd3dDevice->SetTextureStageState(0, D3DTSS_MIPFILTER, D3DTEXF_LINEAR);	
}

